Merge branch 'aj/xfuncname-ada'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # Test the binaries we have just built.  The tests are kept in
38 # t/ subdirectory and are run in 'trash directory' subdirectory.
39 if test -z "$TEST_DIRECTORY"
40 then
41         # We allow tests to override this, in case they want to run tests
42         # outside of t/, e.g. for running tests on the test library
43         # itself.
44         TEST_DIRECTORY=$(pwd)
45 fi
46 if test -z "$TEST_OUTPUT_DIRECTORY"
47 then
48         # Similarly, override this to store the test-results subdir
49         # elsewhere
50         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
51 fi
52 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
53
54 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
55 export PERL_PATH SHELL_PATH
56
57 # For repeatability, reset the environment to known value.
58 LANG=C
59 LC_ALL=C
60 PAGER=cat
61 TZ=UTC
62 TERM=dumb
63 export LANG LC_ALL PAGER TERM TZ
64 EDITOR=:
65 # A call to "unset" with no arguments causes at least Solaris 10
66 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
67 # deriving from the command substitution clustered with the other
68 # ones.
69 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
70         my @env = keys %ENV;
71         my $ok = join("|", qw(
72                 TRACE
73                 DEBUG
74                 USE_LOOKUP
75                 TEST
76                 .*_TEST
77                 PROVE
78                 VALGRIND
79                 PERF_AGGREGATING_LATER
80         ));
81         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
82         print join("\n", @vars);
83 ')
84 unset XDG_CONFIG_HOME
85 GIT_AUTHOR_EMAIL=author@example.com
86 GIT_AUTHOR_NAME='A U Thor'
87 GIT_COMMITTER_EMAIL=committer@example.com
88 GIT_COMMITTER_NAME='C O Mitter'
89 GIT_MERGE_VERBOSITY=5
90 GIT_MERGE_AUTOEDIT=no
91 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
92 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
93 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
94 export EDITOR
95
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
98 unset CDPATH
99
100 unset GREP_OPTIONS
101
102 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
103 1|2|true)
104         echo "* warning: Some tests will not work if GIT_TRACE" \
105                 "is set as to trace on STDERR ! *"
106         echo "* warning: Please set GIT_TRACE to something" \
107                 "other than 1, 2 or true ! *"
108         ;;
109 esac
110
111 # Convenience
112 #
113 # A regexp to match 5 and 40 hexdigits
114 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
115 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
116
117 # Zero SHA-1
118 _z40=0000000000000000000000000000000000000000
119
120 # Line feed
121 LF='
122 '
123
124 export _x05 _x40 _z40 LF
125
126 # Each test should start with something like this, after copyright notices:
127 #
128 # test_description='Description of this test...
129 # This test checks if command xyzzy does the right thing...
130 # '
131 # . ./test-lib.sh
132 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
133                 TERM=$ORIGINAL_TERM &&
134                 export TERM &&
135                 [ -t 1 ] &&
136                 tput bold >/dev/null 2>&1 &&
137                 tput setaf 1 >/dev/null 2>&1 &&
138                 tput sgr0 >/dev/null 2>&1
139         ) &&
140         color=t
141
142 while test "$#" -ne 0
143 do
144         case "$1" in
145         -d|--d|--de|--deb|--debu|--debug)
146                 debug=t; shift ;;
147         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
148                 immediate=t; shift ;;
149         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
150                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
151         -h|--h|--he|--hel|--help)
152                 help=t; shift ;;
153         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
154                 verbose=t; shift ;;
155         -q|--q|--qu|--qui|--quie|--quiet)
156                 # Ignore --quiet under a TAP::Harness. Saying how many tests
157                 # passed without the ok/not ok details is always an error.
158                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
159         --with-dashes)
160                 with_dashes=t; shift ;;
161         --no-color)
162                 color=; shift ;;
163         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
164                 valgrind=t; verbose=t; shift ;;
165         --tee)
166                 shift ;; # was handled already
167         --root=*)
168                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
169                 shift ;;
170         *)
171                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
172         esac
173 done
174
175 if test -n "$color"
176 then
177         say_color () {
178                 (
179                 TERM=$ORIGINAL_TERM
180                 export TERM
181                 case "$1" in
182                 error)
183                         tput bold; tput setaf 1;; # bold red
184                 skip)
185                         tput bold; tput setaf 2;; # bold green
186                 pass)
187                         tput setaf 2;;            # green
188                 info)
189                         tput setaf 3;;            # brown
190                 *)
191                         test -n "$quiet" && return;;
192                 esac
193                 shift
194                 printf "%s" "$*"
195                 tput sgr0
196                 echo
197                 )
198         }
199 else
200         say_color() {
201                 test -z "$1" && test -n "$quiet" && return
202                 shift
203                 echo "$*"
204         }
205 fi
206
207 error () {
208         say_color error "error: $*"
209         GIT_EXIT_OK=t
210         exit 1
211 }
212
213 say () {
214         say_color info "$*"
215 }
216
217 test "${test_description}" != "" ||
218 error "Test script did not set test_description."
219
220 if test "$help" = "t"
221 then
222         echo "$test_description"
223         exit 0
224 fi
225
226 exec 5>&1
227 exec 6<&0
228 if test "$verbose" = "t"
229 then
230         exec 4>&2 3>&1
231 else
232         exec 4>/dev/null 3>/dev/null
233 fi
234
235 test_failure=0
236 test_count=0
237 test_fixed=0
238 test_broken=0
239 test_success=0
240
241 test_external_has_tap=0
242
243 die () {
244         code=$?
245         if test -n "$GIT_EXIT_OK"
246         then
247                 exit $code
248         else
249                 echo >&5 "FATAL: Unexpected exit with code $code"
250                 exit 1
251         fi
252 }
253
254 GIT_EXIT_OK=
255 trap 'die' EXIT
256
257 # The user-facing functions are loaded from a separate file so that
258 # test_perf subshells can have them too
259 . "$TEST_DIRECTORY/test-lib-functions.sh"
260
261 # You are not expected to call test_ok_ and test_failure_ directly, use
262 # the text_expect_* functions instead.
263
264 test_ok_ () {
265         test_success=$(($test_success + 1))
266         say_color "" "ok $test_count - $@"
267 }
268
269 test_failure_ () {
270         test_failure=$(($test_failure + 1))
271         say_color error "not ok - $test_count $1"
272         shift
273         echo "$@" | sed -e 's/^/#       /'
274         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
275 }
276
277 test_known_broken_ok_ () {
278         test_fixed=$(($test_fixed+1))
279         say_color "" "ok $test_count - $@ # TODO known breakage"
280 }
281
282 test_known_broken_failure_ () {
283         test_broken=$(($test_broken+1))
284         say_color skip "not ok $test_count - $@ # TODO known breakage"
285 }
286
287 test_debug () {
288         test "$debug" = "" || eval "$1"
289 }
290
291 test_eval_ () {
292         # This is a separate function because some tests use
293         # "return" to end a test_expect_success block early.
294         eval </dev/null >&3 2>&4 "$*"
295 }
296
297 test_run_ () {
298         test_cleanup=:
299         expecting_failure=$2
300         test_eval_ "$1"
301         eval_ret=$?
302
303         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
304         then
305                 test_eval_ "$test_cleanup"
306         fi
307         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
308         then
309                 echo ""
310         fi
311         return "$eval_ret"
312 }
313
314 test_skip () {
315         test_count=$(($test_count+1))
316         to_skip=
317         for skp in $GIT_SKIP_TESTS
318         do
319                 case $this_test.$test_count in
320                 $skp)
321                         to_skip=t
322                         break
323                 esac
324         done
325         if test -z "$to_skip" && test -n "$test_prereq" &&
326            ! test_have_prereq "$test_prereq"
327         then
328                 to_skip=t
329         fi
330         case "$to_skip" in
331         t)
332                 of_prereq=
333                 if test "$missing_prereq" != "$test_prereq"
334                 then
335                         of_prereq=" of $test_prereq"
336                 fi
337
338                 say_color skip >&3 "skipping test: $@"
339                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
340                 : true
341                 ;;
342         *)
343                 false
344                 ;;
345         esac
346 }
347
348 # stub; perf-lib overrides it
349 test_at_end_hook_ () {
350         :
351 }
352
353 test_done () {
354         GIT_EXIT_OK=t
355
356         if test -z "$HARNESS_ACTIVE"
357         then
358                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
359                 mkdir -p "$test_results_dir"
360                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
361
362                 cat >>"$test_results_path" <<-EOF
363                 total $test_count
364                 success $test_success
365                 fixed $test_fixed
366                 broken $test_broken
367                 failed $test_failure
368
369                 EOF
370         fi
371
372         if test "$test_fixed" != 0
373         then
374                 say_color pass "# fixed $test_fixed known breakage(s)"
375         fi
376         if test "$test_broken" != 0
377         then
378                 say_color error "# still have $test_broken known breakage(s)"
379                 msg="remaining $(($test_count-$test_broken)) test(s)"
380         else
381                 msg="$test_count test(s)"
382         fi
383         case "$test_failure" in
384         0)
385                 # Maybe print SKIP message
386                 if test -n "$skip_all" && test $test_count -gt 0
387                 then
388                         error "Can't use skip_all after running some tests"
389                 fi
390                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
391
392                 if test $test_external_has_tap -eq 0
393                 then
394                         if test $test_count -gt 0
395                         then
396                                 say_color pass "# passed all $msg"
397                         fi
398                         say "1..$test_count$skip_all"
399                 fi
400
401                 test -d "$remove_trash" &&
402                 cd "$(dirname "$remove_trash")" &&
403                 rm -rf "$(basename "$remove_trash")"
404
405                 test_at_end_hook_
406
407                 exit 0 ;;
408
409         *)
410                 if test $test_external_has_tap -eq 0
411                 then
412                         say_color error "# failed $test_failure among $msg"
413                         say "1..$test_count"
414                 fi
415
416                 exit 1 ;;
417
418         esac
419 }
420
421 if test -n "$valgrind"
422 then
423         make_symlink () {
424                 test -h "$2" &&
425                 test "$1" = "$(readlink "$2")" || {
426                         # be super paranoid
427                         if mkdir "$2".lock
428                         then
429                                 rm -f "$2" &&
430                                 ln -s "$1" "$2" &&
431                                 rm -r "$2".lock
432                         else
433                                 while test -d "$2".lock
434                                 do
435                                         say "Waiting for lock on $2."
436                                         sleep 1
437                                 done
438                         fi
439                 }
440         }
441
442         make_valgrind_symlink () {
443                 # handle only executables, unless they are shell libraries that
444                 # need to be in the exec-path.  We will just use "#!" as a
445                 # guess for a shell-script, since we have no idea what the user
446                 # may have configured as the shell path.
447                 test -x "$1" ||
448                 test "#!" = "$(head -c 2 <"$1")" ||
449                 return;
450
451                 base=$(basename "$1")
452                 symlink_target=$GIT_BUILD_DIR/$base
453                 # do not override scripts
454                 if test -x "$symlink_target" &&
455                     test ! -d "$symlink_target" &&
456                     test "#!" != "$(head -c 2 < "$symlink_target")"
457                 then
458                         symlink_target=../valgrind.sh
459                 fi
460                 case "$base" in
461                 *.sh|*.perl)
462                         symlink_target=../unprocessed-script
463                 esac
464                 # create the link, or replace it if it is out of date
465                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
466         }
467
468         # override all git executables in TEST_DIRECTORY/..
469         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
470         mkdir -p "$GIT_VALGRIND"/bin
471         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
472         do
473                 make_valgrind_symlink $file
474         done
475         # special-case the mergetools loadables
476         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
477         OLDIFS=$IFS
478         IFS=:
479         for path in $PATH
480         do
481                 ls "$path"/git-* 2> /dev/null |
482                 while read file
483                 do
484                         make_valgrind_symlink "$file"
485                 done
486         done
487         IFS=$OLDIFS
488         PATH=$GIT_VALGRIND/bin:$PATH
489         GIT_EXEC_PATH=$GIT_VALGRIND/bin
490         export GIT_VALGRIND
491 elif test -n "$GIT_TEST_INSTALLED"
492 then
493         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
494         error "Cannot run git from $GIT_TEST_INSTALLED."
495         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
496         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
497 else # normal case, use ../bin-wrappers only unless $with_dashes:
498         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
499         if ! test -x "$git_bin_dir/git"
500         then
501                 if test -z "$with_dashes"
502                 then
503                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
504                 fi
505                 with_dashes=t
506         fi
507         PATH="$git_bin_dir:$PATH"
508         GIT_EXEC_PATH=$GIT_BUILD_DIR
509         if test -n "$with_dashes"
510         then
511                 PATH="$GIT_BUILD_DIR:$PATH"
512         fi
513 fi
514 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
515 unset GIT_CONFIG
516 GIT_CONFIG_NOSYSTEM=1
517 GIT_ATTR_NOSYSTEM=1
518 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
519
520 if test -z "$GIT_TEST_CMP"
521 then
522         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
523         then
524                 GIT_TEST_CMP="$DIFF -c"
525         else
526                 GIT_TEST_CMP="$DIFF -u"
527         fi
528 fi
529
530 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
531 export GITPERLLIB
532 test -d "$GIT_BUILD_DIR"/templates/blt || {
533         error "You haven't built things yet, have you?"
534 }
535
536 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
537 then
538         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
539         export GITPYTHONLIB
540         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
541                 error "You haven't built git_remote_helpers yet, have you?"
542         }
543 fi
544
545 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
546 then
547         echo >&2 'You need to build test-chmtime:'
548         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
549         exit 1
550 fi
551
552 # Test repository
553 test="trash directory.$(basename "$0" .sh)"
554 test -n "$root" && test="$root/$test"
555 case "$test" in
556 /*) TRASH_DIRECTORY="$test" ;;
557  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
558 esac
559 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
560 rm -fr "$test" || {
561         GIT_EXIT_OK=t
562         echo >&5 "FATAL: Cannot prepare test area"
563         exit 1
564 }
565
566 HOME="$TRASH_DIRECTORY"
567 export HOME
568
569 if test -z "$TEST_NO_CREATE_REPO"
570 then
571         test_create_repo "$test"
572 else
573         mkdir -p "$test"
574 fi
575 # Use -P to resolve symlinks in our working directory so that the cwd
576 # in subprocesses like git equals our $PWD (for pathname comparisons).
577 cd -P "$test" || exit 1
578
579 this_test=${0##*/}
580 this_test=${this_test%%-*}
581 for skp in $GIT_SKIP_TESTS
582 do
583         case "$this_test" in
584         $skp)
585                 say_color skip >&3 "skipping test $this_test altogether"
586                 skip_all="skip all tests in $this_test"
587                 test_done
588         esac
589 done
590
591 # Provide an implementation of the 'yes' utility
592 yes () {
593         if test $# = 0
594         then
595                 y=y
596         else
597                 y="$*"
598         fi
599
600         while echo "$y"
601         do
602                 :
603         done
604 }
605
606 # Fix some commands on Windows
607 case $(uname -s) in
608 *MINGW*)
609         # Windows has its own (incompatible) sort and find
610         sort () {
611                 /usr/bin/sort "$@"
612         }
613         find () {
614                 /usr/bin/find "$@"
615         }
616         sum () {
617                 md5sum "$@"
618         }
619         # git sees Windows-style pwd
620         pwd () {
621                 builtin pwd -W
622         }
623         # no POSIX permissions
624         # backslashes in pathspec are converted to '/'
625         # exec does not inherit the PID
626         test_set_prereq MINGW
627         test_set_prereq SED_STRIPS_CR
628         ;;
629 *CYGWIN*)
630         test_set_prereq POSIXPERM
631         test_set_prereq EXECKEEPSPID
632         test_set_prereq NOT_MINGW
633         test_set_prereq SED_STRIPS_CR
634         ;;
635 *)
636         test_set_prereq POSIXPERM
637         test_set_prereq BSLASHPSPEC
638         test_set_prereq EXECKEEPSPID
639         test_set_prereq NOT_MINGW
640         ;;
641 esac
642
643 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
644 test -z "$NO_PERL" && test_set_prereq PERL
645 test -z "$NO_PYTHON" && test_set_prereq PYTHON
646 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
647 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
648
649 # Can we rely on git's output in the C locale?
650 if test -n "$GETTEXT_POISON"
651 then
652         GIT_GETTEXT_POISON=YesPlease
653         export GIT_GETTEXT_POISON
654         test_set_prereq GETTEXT_POISON
655 else
656         test_set_prereq C_LOCALE_OUTPUT
657 fi
658
659 # Use this instead of test_cmp to compare files that contain expected and
660 # actual output from git commands that can be translated.  When running
661 # under GETTEXT_POISON this pretends that the command produced expected
662 # results.
663 test_i18ncmp () {
664         test -n "$GETTEXT_POISON" || test_cmp "$@"
665 }
666
667 # Use this instead of "grep expected-string actual" to see if the
668 # output from a git command that can be translated either contains an
669 # expected string, or does not contain an unwanted one.  When running
670 # under GETTEXT_POISON this pretends that the command produced expected
671 # results.
672 test_i18ngrep () {
673         if test -n "$GETTEXT_POISON"
674         then
675             : # pretend success
676         elif test "x!" = "x$1"
677         then
678                 shift
679                 ! grep "$@"
680         else
681                 grep "$@"
682         fi
683 }
684
685 test_lazy_prereq SYMLINKS '
686         # test whether the filesystem supports symbolic links
687         ln -s x y && test -h y
688 '
689
690 test_lazy_prereq CASE_INSENSITIVE_FS '
691         echo good >CamelCase &&
692         echo bad >camelcase &&
693         test "$(cat CamelCase)" != good
694 '
695
696 test_lazy_prereq UTF8_NFD_TO_NFC '
697         # check whether FS converts nfd unicode to nfc
698         auml=$(printf "\303\244")
699         aumlcdiar=$(printf "\141\314\210")
700         >"$auml" &&
701         case "$(echo *)" in
702         "$aumlcdiar")
703                 true ;;
704         *)
705                 false ;;
706         esac
707 '
708
709 # When the tests are run as root, permission tests will report that
710 # things are writable when they shouldn't be.
711 test -w / || test_set_prereq SANITY